define("smashthepigComponentsTensionPort", ["componentmodelComponentApi", "clientkernelEventbusApi"],
    function(componentmodelComponentApi, clientkernelEventbusApi) {
        "use strict";

        function $iterator(o) {
            if (o instanceof Array) return function() {
                return {
                    cur: 0,
                    arr: o,
                    hasNext: function() {
                        return this.cur < this.arr.length;
                    },
                    next: function() {
                        return this.arr[this.cur++];
                    }
                };
            };
            return typeof(o.iterator) == 'function' ? $bind(o, o.iterator) : o.iterator;
        };;
        var $fid = 0;

        function $bind(o, m) {
            if (m == null) return null;
            if (m.__id__ == null) m.__id__ = $fid++;
            var f;
            if (o.hx__closures__ == null) o.hx__closures__ = {};
            else f = o.hx__closures__[m.__id__];
            if (f == null) {
                f = function() {
                    return f.method.apply(f.scope, arguments);
                };
                f.scope = o;
                f.method = m;
                o.hx__closures__[m.__id__] = f;
            }
            return f;
        };
        var $_;
        var $estr = function() {
            return _hcmn_.js_Boot.__string_rec(this, '');
        };
        if (typeof haxe == 'undefined') {
            var haxe = {};
        };

        haxe.IMap = function() {}
        haxe.IMap.prototype = {

        };
        if (typeof smashthepigComponentsTensionPort == 'undefined') {
            var smashthepigComponentsTensionPort = {};
        };

        smashthepigComponentsTensionPort.ITensionImplementationPort = function() {}
        smashthepigComponentsTensionPort.ITensionImplementationPort.prototype = {

            getShow: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getShowTensionFrame: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getHideTensionFrame: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };

        smashthepigComponentsTensionPort.ITensionPort = function() {}
        smashthepigComponentsTensionPort.ITensionPort.prototype = {

            getShow: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getShowTensionFrame: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getHideTensionFrame: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };
        smashthepigComponentsTensionPort.TensionDeclaration = function() {};
        smashthepigComponentsTensionPort.TensionDeclaration = ck_implements(smashthepigComponentsTensionPort.TensionDeclaration, componentmodelComponentApi.IComponentDeclaration);
        smashthepigComponentsTensionPort.TensionDeclaration.__interfaces__ = [componentmodelComponentApi.IComponentDeclaration];
        smashthepigComponentsTensionPort.TensionDeclaration.__name__ = ["smashthepigComponentsTensionPort", "TensionDeclaration"];
        smashthepigComponentsTensionPort.TensionDeclaration.prototype.getChildComponents = function() {
            return null;
        };
        smashthepigComponentsTensionPort.TensionDeclaration.prototype.getReferredComponents = function() {
            return null;
        };
        smashthepigComponentsTensionPort.TensionDeclaration.prototype.getImplementedPorts = function() {
            return [smashthepigComponentsTensionPort.ITensionImplementationPort];
        };
        smashthepigComponentsTensionPort.TensionDeclaration.prototype.getUsedPorts = function() {
            return [smashthepigComponentsTensionPort.ITensionPort];
        };
        smashthepigComponentsTensionPort.TensionDeclaration.prototype.__class__ = smashthepigComponentsTensionPort.TensionDeclaration;
        smashthepigComponentsTensionPort.TensionPort = function(bus) {
            this.hideTensionFrame = new clientkernelEventbusApi.Topic("tension:hideTensionFrame");
            this.showTensionFrame = new clientkernelEventbusApi.Topic("tension:showTensionFrame");
            this.show = new clientkernelEventbusApi.Topic("tension:show");
            this.show.connect(bus);
            this.showTensionFrame.connect(bus);
            this.hideTensionFrame.connect(bus);
        };
        smashthepigComponentsTensionPort.TensionPort = ck_implements(smashthepigComponentsTensionPort.TensionPort, smashthepigComponentsTensionPort.ITensionPort);
        smashthepigComponentsTensionPort.TensionPort = ck_implements(smashthepigComponentsTensionPort.TensionPort, smashthepigComponentsTensionPort.ITensionImplementationPort);
        smashthepigComponentsTensionPort.TensionPort.__interfaces__ = [smashthepigComponentsTensionPort.ITensionPort, smashthepigComponentsTensionPort.ITensionImplementationPort];
        smashthepigComponentsTensionPort.TensionPort.__name__ = ["smashthepigComponentsTensionPort", "TensionPort"];
        smashthepigComponentsTensionPort.TensionPort.prototype.show = null;
        smashthepigComponentsTensionPort.TensionPort.prototype.showTensionFrame = null;
        smashthepigComponentsTensionPort.TensionPort.prototype.hideTensionFrame = null;
        smashthepigComponentsTensionPort.TensionPort.prototype.getShow = function() {
            return this.show;
        };
        smashthepigComponentsTensionPort.TensionPort.prototype.getShowTensionFrame = function() {
            return this.showTensionFrame;
        };
        smashthepigComponentsTensionPort.TensionPort.prototype.getHideTensionFrame = function() {
            return this.hideTensionFrame;
        };
        smashthepigComponentsTensionPort.TensionPort.prototype.__class__ = smashthepigComponentsTensionPort.TensionPort;
        smashthepigComponentsTensionPort.TensionPortFactory = function() {};
        smashthepigComponentsTensionPort.TensionPortFactory = ck_implements(smashthepigComponentsTensionPort.TensionPortFactory, componentmodelComponentApi.IPortFactory);
        smashthepigComponentsTensionPort.TensionPortFactory.__interfaces__ = [componentmodelComponentApi.IPortFactory];
        smashthepigComponentsTensionPort.TensionPortFactory.__name__ = ["smashthepigComponentsTensionPort", "TensionPortFactory"];
        smashthepigComponentsTensionPort.TensionPortFactory.prototype.provide = function(channel) {
            return new smashthepigComponentsTensionPort.TensionPort(channel);
        };
        smashthepigComponentsTensionPort.TensionPortFactory.prototype["use"] = function(channel) {
            return new smashthepigComponentsTensionPort.TensionPort(channel);
        };
        smashthepigComponentsTensionPort.TensionPortFactory.prototype.__class__ = smashthepigComponentsTensionPort.TensionPortFactory;
        smashthepigComponentsTensionPort.ShowTensionPayload = function(data, reelId, stopSpin, spinStopped) {
            this.data = data;
            this.stopSpin = stopSpin;
            this.spinStopped = spinStopped;
            this.reelId = reelId;
        };
        smashthepigComponentsTensionPort.ShowTensionPayload.__name__ = ["smashthepigComponentsTensionPort", "ShowTensionPayload"];
        smashthepigComponentsTensionPort.ShowTensionPayload.prototype.data = null;
        smashthepigComponentsTensionPort.ShowTensionPayload.prototype.reelId = null;
        smashthepigComponentsTensionPort.ShowTensionPayload.prototype.stopSpin = null;
        smashthepigComponentsTensionPort.ShowTensionPayload.prototype.spinStopped = null;
        smashthepigComponentsTensionPort.ShowTensionPayload.prototype.__class__ = smashthepigComponentsTensionPort.ShowTensionPayload;
        return {
            exports: smashthepigComponentsTensionPort
        };
    });
//# sourceURL=smashThePigTensionPort.js